
#include <stdio.h>
#include <stdlib.h>
#include <glpk.h>
#include <iostream>
#include <sstream>
#include <cmath>
#include "RW4DW.h"
#include <limits>

bool WRITE_ALL_MASTER=false;

//25 letters
const string varname[]={"a","b","c","d","e","f","g","h","k","j","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
"aa","bb","cc","dd","ee","ff","gg","hh","kk","jj","mm","nn","oo","pp","qq","rr","ss","tt","uu","vv","ww","xx","yy","zz",
"aaa","bbb","ccc","ddd","eee","fff","ggg","hhh","kkk","jjj","mmm","nnn","ooo","ppp","qqq","rrr","sss","ttt","uuu","vvv","www","xxx","yyy","zzz",
"aaaa","bbbb","cccc","dddd","eeee","ffff","gggg","hhhh","kkkk","jjjj","mmmm","nnnn","oooo","pppp","qqqq","rrrr","ssss","tttt","uuuu","vvvv","wwww","xxxx","yyyy","zzzz"
};

//vector<int> ERASED;

extern vector<int> NOTERASED;


double LIM3DERROR=1.5;

const double TOL=0.0000001;


bool FindErased(const int cols, const vector<int>ERASED){
    
    int ii=0;
    while(ii<ERASED.size()){
	if (ERASED[ii]==cols){
	    return true;
	}
	ii++;
    }
    return false;
  
}


int LookforVar(string lookvar, vector<string> &names){
  
    for (int ii=0;ii<names.size();ii++){
	if (names[ii].compare(lookvar)==0){
	    return ii;
	}
    }
    return -1;
  
}

int maxV(const vector<int> VEC, int &maxpos){
  
    int maxvalue=-100000;
    for (int v=0;v<VEC.size();v++){
	if (VEC[v]>maxvalue){
	    maxvalue=VEC[v];
	    maxpos=v;
	}
    }
    return maxvalue;
  
}

void UpdateID(CSet &SET, const int oldclass, const int newclass, const int fr_ini, const int fr_end, const int ncam){
	
	for (int fr=fr_ini;fr<=fr_end;fr++){
	    for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		if (SET.frames[fr].cam[ncam].objects2d[p].autoclass==oldclass){
		    SET.frames[fr].cam[ncam].objects2d[p].autoclass=newclass;
		}
	    }   
	}
		
}

void CheckEnterLeaveFrames(const int nobj, CSet &SET, const int fr_ini, const int fr_end, const vector<double> solu, const vector<int> Ncols, vector<string> names,  const vector <int> oldcolors, vector<int> &ObjColors ){
	
	int indxname=-1,maxpos;
	vector<int> enterFrame;
	vector<int> leaveFrame; 
	vector<int> oldclass;
	ObjColors.clear();
	for (int ncam=0;ncam<SET.nCam;ncam++){
	  enterFrame.push_back(-1);
	  leaveFrame.push_back(-1);
	  oldclass.push_back(-1);
	  ObjColors.push_back(-1);
	}
	
	// INPUTS 
	int cols=0;
	for (int fr=fr_ini;fr<=fr_end;fr++){
	    for (int ncam=0;ncam<SET.nCam;ncam++){
		for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		    if (!SET.frames[fr].cam[ncam].objects2d[p].created){
			stringstream lookvar;
			lookvar << varname[nobj] << cols;
			indxname=LookforVar(lookvar.str(),names);
			if (indxname>-1){
			      if (abs(solu[indxname])==1){
				  enterFrame[ncam]=fr;
				  if (SET.frames[fr].cam[ncam].objects2d[p].autoclass>-1){
				      oldclass[ncam]=SET.frames[fr].cam[ncam].objects2d[p].autoclass;
				  }
			      }
			}
			cols++;
		    }
		}
	    }
	}
	//OUTPUTS
	for (int fr=fr_ini;fr<=fr_end;fr++){
	    for (int ncam=0;ncam<SET.nCam;ncam++){
		for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		    if (!SET.frames[fr].cam[ncam].objects2d[p].created){
			stringstream lookvar;
			lookvar << varname[nobj] << cols;
			indxname=LookforVar(lookvar.str(),names);
			if (indxname>-1){
			      if (abs(solu[indxname])==1){
				  leaveFrame[ncam]=fr;
			      }
			}
			cols++;
		    }
		}
	    }
	}
	
	
	
	bool noid=true;
	for (int ncam=0;ncam<oldclass.size();ncam++){
	    if (oldclass[ncam]>-1){
		noid=false;
	    }
	}
	
	if (noid){
	    SET.usedColors++;
	    ObjColors[0]=SET.usedColors;
	    
	    for (int ncam=1;ncam<enterFrame.size();ncam++){
		if (enterFrame[ncam]>-1 & leaveFrame[ncam]>-1){
		    for (int ncam2=ncam-1;ncam2>=0;ncam2--){
			if (enterFrame[ncam2]>-1 & leaveFrame[ncam2]>-1){
			    if (enterFrame[ncam]<leaveFrame[ncam2] | leaveFrame[ncam]>enterFrame[ncam2]){
				ObjColors[ncam]=ObjColors[ncam2];
			    }
			}
		    }
		    if (ObjColors[ncam]==-1){
			SET.usedColors++;
			ObjColors[ncam]=SET.usedColors;
		    }
		}
	    }
	}else{
	    for (int ncam=0;ncam<oldclass.size();ncam++){
		ObjColors[ncam]=oldclass[ncam];
	    }
	    int newclass=maxV(oldclass,maxpos);
   
	    if (enterFrame[maxpos]>-1 & leaveFrame[maxpos]>-1){
		for (int ncam2=0;ncam2<oldclass.size();ncam2++){
		    if (enterFrame[ncam2]>-1 & leaveFrame[ncam2]>-1){
			if (enterFrame[maxpos]<leaveFrame[ncam2] | leaveFrame[maxpos]>enterFrame[ncam2]){
			    ObjColors[ncam2]=newclass;
			}
		    }
		    if (ObjColors[ncam2]==-1){
			SET.usedColors++;
			ObjColors[ncam2]=SET.usedColors;
		    }
		}
	    }
  
	}
	
	for (int ncam=0;ncam<oldclass.size();ncam++){
	    for (int jj=0;jj<oldcolors.size();jj++){
		if (ObjColors[ncam]==oldcolors[jj]){
		    SET.usedColors++;
		    ObjColors[ncam]=SET.usedColors;
		}
	    }
	}
	
	
	for (int ncam=0;ncam<SET.nCam;ncam++){
	    for (int p=0;p<SET.frames[fr_ini].cam[ncam].objects2d.size();p++){
		SET.frames[fr_ini].cam[ncam].objects2d[p].id=-1;
	    }
	}
	
	
	
}



void Interpolate(CSet &SET, const int fr, const int jump, const int p, const int p2, const int ncam){

	double speed[3];
	double speedpix[2];
	double timediff=SET.frames[fr+jump].cam[ncam].objects2d[p2].timet-SET.frames[fr].cam[ncam].objects2d[p].timet;
	speed[0]=(SET.frames[fr+jump].cam[ncam].objects3d[p2].x-SET.frames[fr].cam[ncam].objects3d[p].x)/timediff;
	speed[1]=(SET.frames[fr+jump].cam[ncam].objects3d[p2].y-SET.frames[fr].cam[ncam].objects3d[p].y)/timediff;
	speed[2]=(SET.frames[fr+jump].cam[ncam].objects3d[p2].z-SET.frames[fr].cam[ncam].objects3d[p].z)/timediff;
	speedpix[0]=(SET.frames[fr+jump].cam[ncam].objects2d[p2].x-SET.frames[fr].cam[ncam].objects2d[p].x)/timediff;
	speedpix[1]=(SET.frames[fr+jump].cam[ncam].objects2d[p2].y-SET.frames[fr].cam[ncam].objects2d[p].y)/timediff;
	CData newobj2d;
	CData newobj3d;
	for (int intfr=fr+1;intfr<fr+jump;intfr++){
	    double tdiff=timediff*(intfr-fr)/jump;
	    newobj2d.timet=SET.frames[fr].cam[ncam].objects2d[0].timet+tdiff;
	    newobj3d.timet=SET.frames[fr].cam[ncam].objects2d[0].timet+tdiff;
	    newobj3d.x=SET.frames[fr].cam[ncam].objects3d[p].x+speed[0]*tdiff;
	    newobj3d.y=SET.frames[fr].cam[ncam].objects3d[p].y+speed[1]*tdiff;
	    newobj3d.z=SET.frames[fr].cam[ncam].objects3d[p].z+speed[2]*tdiff;
	    newobj2d.x=round(SET.frames[fr].cam[ncam].objects2d[p].x+speedpix[0]*tdiff);
	    newobj2d.y=round(SET.frames[fr].cam[ncam].objects2d[p].y+speedpix[1]*tdiff);
	    newobj2d.created=true;
	    newobj2d.width=SET.frames[fr].cam[ncam].objects2d[p].width;
	    newobj2d.height=SET.frames[fr].cam[ncam].objects2d[p].height;
	    newobj2d.autoclass=SET.frames[fr].cam[ncam].objects2d[p].autoclass;
	    SET.frames[intfr].cam[ncam].objects2d.push_back(newobj2d);
	    SET.frames[intfr].cam[ncam].objects3d.push_back(newobj3d);
	}
}


void WriteToLP(CSet &SET,  const int fr_ini, const int fr_end, vector<double> &solu, const vector<int> Ncols, vector<string> &names){

    // [0] object to 2d, [1] static 2d, [2] temporal 2d, [3] object to 3d, [4] 3d distances 

    int indxname=0; int sizeNcols=Ncols.size(),maxpos=-1;
    vector<int> equivalentNums;
    vector<int> objColors;
    vector<int> oldcolors;
    

    for (int nobj=0;nobj<SET.nObj;nobj++){
	
	CheckEnterLeaveFrames(nobj,SET,fr_ini,fr_end, solu,Ncols, names,oldcolors,objColors);
	
	// INPUTS 
	int cols=0;
	
	for (int fr=fr_ini;fr<=fr_end;fr++){
	    for (int ncam=0;ncam<SET.nCam;ncam++){
		for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		    if (!SET.frames[fr].cam[ncam].objects2d[p].created){
			stringstream lookvar;
			lookvar << varname[nobj] << cols;
			indxname=LookforVar(lookvar.str(),names);
			if (indxname>-1){
			      if (abs(solu[indxname])==1){
				 SET.frames[fr].cam[ncam].objects2d[p].autoclass=objColors[ncam];
			      }
			      solu.erase(solu.begin()+indxname);
			      names.erase(names.begin()+indxname);

			}
			cols++;
		    }
		}
	    }
	}
	cols=Ncols[2];
	
	// TEMPORAL BETWEEN 2D DETECTIONS 
	for (int fr=fr_ini;fr<fr_end;fr++){
	    for (int ncam=0;ncam<SET.nCam;ncam++){
		    for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
			   if (!SET.frames[fr].cam[ncam].objects2d[p].created){
				for (int jump=1;jump<=SET.RecoverFrames;jump++){
					if ((fr+jump)<=fr_end){
						for (int p2=0;p2<SET.frames[fr+jump].cam[ncam].objects2d.size();p2++){
						       if (!SET.frames[fr+jump].cam[ncam].objects2d[p2].created){
							    if (SET.frames[fr+jump].cam[ncam].objects2d[p2].autoclass<0){
								stringstream lookvar;
								lookvar << varname[nobj] << cols;
								indxname=LookforVar(lookvar.str(),names);
								if (indxname>-1){
								      if (solu[indxname]==1){
									  if (SET.frames[fr].cam[ncam].objects2d[p].autoclass<0){
									      cout << "Wrong class for TEMP matching!!!!!" << endl;
									  }
									  SET.frames[fr+jump].cam[ncam].objects2d[p2].autoclass=SET.frames[fr].cam[ncam].objects2d[p].autoclass;
									
								      }
								      if (jump>1){ //interpolate positions
									  Interpolate(SET,fr,jump,p,p2, ncam);
								      }
								      solu.erase(solu.begin()+indxname);
								      names.erase(names.begin()+indxname);
								}  
							    }
							    cols++;
						       }
						}
					}
				}
			   }
		    }
	      }
	} 
	SET.usedColors=max(SET.usedColors,maxV(objColors,maxpos));
	for (int m=0;m<objColors.size();m++){
	    oldcolors.push_back(objColors[m]);
	}
    
    }
    
  
}


int ReadCPLEXSolution(CSet &SET,  const int fr_ini, const int fr_end, const double tdiff, const vector<int> Ncols){
  
    ifstream soluFile;
    soluFile.open(SET.ofilename);
    vector<double>solu;
    vector<string>names;
    double sol;
    string namevar;
    
    cout << "Reading CPLEX " << endl;
    
    while (!soluFile.eof()){
	  soluFile >> namevar;
	  soluFile >> sol;
	  if ((1.0-abs(sol))>EPS && abs(sol)>EPS){
	      cout << "NON INTEGER SOLUTIONS " << abs(sol) << endl;
	      return -1;
	  }else if ((1.0-abs(sol))<EPS){
	    solu.push_back(abs(sol));
	    names.push_back(namevar);
	  }
    }
    
    cout << "Done reading CPLEX" << endl;
    
    soluFile.close();

    WriteToLP(SET,fr_ini,fr_end,solu,Ncols,names);
    return 0;
}


int Create3DPossibilities( CSet &SET, const int fr_ini, const int fr_end){
  
    double dist=-1;
    CData newobj3d;
    CCamera newcam;
    LIM3DERROR=0.001;
    
    for (int fr=fr_ini;fr<=fr_end;fr++){
	for (int ncam=0;ncam<SET.nCam;ncam++){
	    for (int ncam2=0;ncam2<SET.nCam;ncam2++){
		  SET.frames[fr].cam[ncam].cam2.push_back(newcam);
	    }
	    for (int ncam2=ncam+1;ncam2<SET.nCam;ncam2++){
		for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		    for (int p2=0;p2<SET.frames[fr].cam[ncam2].objects2d.size();p2++){
			dist=SET.LineDistance(SET.frames[fr].cam[ncam].objects3d[p],SET.frames[fr].cam[ncam2].objects3d[p2],newobj3d);
			if (dist<=LIM3DERROR){//SET.maxspeed){
			    newobj3d.errdist=dist;
			    newobj3d.p=p;
			    newobj3d.p2=p2;
			    newobj3d.timet=SET.frames[fr].cam[ncam].objects2d[p].timet;
			    SET.frames[fr].cam[ncam].cam2[ncam2].objects3d.push_back(newobj3d);
			}else{
			    newobj3d.errdist=-1.0;
			    newobj3d.p=p;
			    newobj3d.p2=p2;
			}
			SET.frames[fr].cam[ncam].cam2[ncam2].objects3d.push_back(newobj3d);
		    }
		}

	    }
	}
    }
  
}


int Create3DPossibilitiesMultiPeople( CSet &SET, const int fr_ini, const int fr_end){
  
    double dist=-1;
    int iniwhere=fr_ini;
    CData newobj3d;
    CCamera newcam;
    
    for (int fr=fr_ini;fr<=fr_end;fr++){
	for (int ncam=0;ncam<SET.nCam;ncam++){
	    for (int ncam2=0;ncam2<SET.nCam;ncam2++){
		  SET.frames[fr].cam[ncam].cam2.push_back(newcam);
	    }
	    for (int ncam2=ncam+1;ncam2<SET.nCam;ncam2++){
		for (int p=0;p<SET.frames[fr].cam[ncam].objects3d.size();p++){
		    for (int p2=0;p2<SET.frames[fr].cam[ncam2].objects3d.size();p2++){
			dist=SET.Distance(SET.frames[fr].cam[ncam].objects3d[p],SET.frames[fr].cam[ncam2].objects3d[p2]);     
			if (dist<=LIM3DERROR){//in meters!!! 0.5 meters apart it's another person
			    newobj3d.x=0.5*(SET.frames[fr].cam[ncam].objects3d[p].x+SET.frames[fr].cam[ncam2].objects3d[p2].x);
			    newobj3d.y=0.5*(SET.frames[fr].cam[ncam].objects3d[p].y+SET.frames[fr].cam[ncam2].objects3d[p2].y);
			    newobj3d.z=0; //case of multiple people tracking
			    newobj3d.errdist=dist;
			    newobj3d.p=p;
			    newobj3d.p2=p2;
			    newobj3d.timet=SET.frames[fr].cam[ncam].objects2d[p].timet;
			}else{
			    newobj3d.errdist=-1.0;
			    newobj3d.p=p;
			    newobj3d.p2=p2;
			}
			SET.frames[fr].cam[ncam].cam2[ncam2].objects3d.push_back(newobj3d);
		    }
		}

	    }
	}
    }
  
}


vector<int> CreateObjectiveFunction(CSet &SET,const int fr_ini, const int fr_end, const int nobj, vector<int> Ncols){
  
    double INOUTcost=-log(0.1), DISTcost=-1, dist=-1, timediff=-1;
    int cols=0;

  
	  Ncols.push_back(cols);
	  // INPUTS 
	  for (int fr=fr_ini;fr<=fr_end;fr++){
	      for (int ncam=0;ncam<SET.nCam;ncam++){
		  for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		      if (fr==fr_ini){
		    	  if (!WRITE_ALL_MASTER)
		    		  SET.subP << "+ 0 " << varname[nobj] << cols << " ";

		    	  SET.masterP << "+ 0 " << varname[nobj] << cols << " ";
		      }else{
		    	  if (!WRITE_ALL_MASTER)
		    		  SET.subP << "+ " << INOUTcost << " " << varname[nobj] << cols << " ";
		    	  SET.masterP << "+ " << INOUTcost << " " << varname[nobj] << cols << " ";
		      }
		      cols++;
		  }
	      }
	  }
	 
	  
	  
	  // OUTPUTS 
	  for (int fr=fr_ini;fr<=fr_end;fr++){
	      for (int ncam=0;ncam<SET.nCam;ncam++){
		  for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		      if (fr==fr_end){
		    	  if (!WRITE_ALL_MASTER)
					  SET.subP << "+ 0 " << varname[nobj] << cols << " ";
		    	  SET.masterP << "+ 0 " << varname[nobj] << cols << " ";
		      }else{
		    	  if (!WRITE_ALL_MASTER)
		    		  SET.subP << "+ " << INOUTcost << " " << varname[nobj] << cols << " ";
		    	  SET.masterP << "+ " << INOUTcost << " " << varname[nobj] << cols << " ";
		      }
		      cols++;
		  }
	      }
	  }
	  Ncols.push_back(cols);    
	  

	  double STATICcost=-log(0.1);
	 
	  // STATIC BETWEEN 2 NODES OF SAME DETECTION (commented because cost=0 for MoCap)
	  for (int fr=fr_ini;fr<=fr_end;fr++){
	      for (int ncam=0;ncam<SET.nCam;ncam++){
		  for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
			  if (!WRITE_ALL_MASTER)
				  SET.subP << "- " << STATICcost << " " << varname[nobj] << cols << " ";
			  SET.masterP << "- " << STATICcost << " " << varname[nobj] << cols << " ";
			  cols++;
		  }
	      }
	  }
	  Ncols.push_back(cols);
		  
		  
	  
	  // TEMPORAL BETWEEN 2D DETECTIONS 
	  CData dummy;
	  for (int fr=fr_ini;fr<fr_end;fr++){
	      for (int ncam=0;ncam<SET.nCam;ncam++){
		      for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
			      for (int jump=1;jump<=SET.RecoverFrames;jump++){
				      if ((fr+jump)<=fr_end){
					      for (int p2=0;p2<SET.frames[fr+jump].cam[ncam].objects2d.size();p2++){
						      
						      dist=SET.DistancePix(SET.frames[fr].cam[ncam].objects2d[p],SET.frames[fr+jump].cam[ncam].objects2d[p2]);
						      timediff=SET.frames[fr+jump].cam[ncam].objects2d[p2].timet-SET.frames[fr].cam[ncam].objects2d[p].timet;
					
						      DISTcost=abs(-log(SET.DistProbability(dist,timediff,SET.maxspeed))-log(pow(SET.base_jump,jump-1)));
						      
						      
						      if (!isinf(DISTcost) & !isnan(DISTcost)){
							  NOTERASED.push_back(cols);
							  if (!WRITE_ALL_MASTER)
								  SET.subP << "+ " << DISTcost << " " << varname[nobj] << cols << " ";
							  SET.masterP << "+ " << DISTcost << " " << varname[nobj] << cols << " ";
						      }
						      cols++;
					      }
				      }
			      }
		      }
		}
	  } 
	
	
	  Ncols.push_back(cols);


      
	  cols=Ncols[3];
	  
	  // OBJECTS TO 3D POSSIBILITIES 
	  for (int fr=fr_ini;fr<=fr_end;fr++){
		for (int ncam=0;ncam<SET.nCam;ncam++){
			for (int ncam2=ncam+1;ncam2<SET.nCam;ncam2++){
			      for (int p=0;p<SET.frames[fr].cam[ncam].cam2[ncam2].objects3d.size();p++){
				  if (SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].errdist>-1){
				      if (SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].errdist<=(LIM3DERROR/2)){
					  DISTcost=1-SET.DistProbability(SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].errdist,1,LIM3DERROR/2);  
					  DISTcost=max(TOL,abs(-log(max(TOL,DISTcost))));  
					  if (!isinf(DISTcost) & !isnan(DISTcost)){
					      NOTERASED.push_back(cols);
					      if (!WRITE_ALL_MASTER)
					    	  SET.subP << "- " << DISTcost << " " << varname[nobj] << cols << " ";
					      SET.masterP << "- " << DISTcost << " " << varname[nobj] << cols << " ";
					  }
					  
				      }else{
					  DISTcost=SET.DistProbability(SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].errdist-LIM3DERROR/2,1,LIM3DERROR/2);
					  DISTcost=max(TOL,abs(-log(max(TOL,DISTcost))));  
					  if (!isinf(DISTcost) & !isnan(DISTcost)){
					      NOTERASED.push_back(cols);
					      if (!WRITE_ALL_MASTER)
					    	  SET.subP << "+ " << DISTcost << " " << varname[nobj] << cols << " ";
					      SET.masterP << "+ " << DISTcost << " " << varname[nobj] << cols << " ";
					  }
					  
					
				      }
				  }

				cols++;
			      }
			}
		}
	  }
	  
	  Ncols.push_back(cols);


	  cols=Ncols[4];

	  
	  //3D ARTICULATED DISTANCES
	  for (int fr=fr_ini;fr<=fr_end;fr++){
	      for (int ncam=0;ncam<SET.nCam;ncam++){
		    for (int ncam2=ncam+1;ncam2<SET.nCam;ncam2++){
			    for (int p=0;p<SET.frames[fr].cam[ncam].cam2[ncam2].objects3d.size();p++){
				for (int ncam3=ncam;ncam3<SET.nCam;ncam3++){
				      for (int ncam4=ncam3+1;ncam4<SET.nCam;ncam4++){
					      for (int p2=0;p2<SET.frames[fr].cam[ncam3].cam2[ncam4].objects3d.size();p2++){
						    if (ncam3>ncam || ncam4>ncam2){
							if (SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].errdist>-1 & SET.frames[fr].cam[ncam3].cam2[ncam4].objects3d[p2].errdist>-1){
							    
							    DISTcost=SET.Distance(SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p],SET.frames[fr].cam[ncam3].cam2[ncam4].objects3d[p2]);
								  DISTcost=1-SET.DistProbability(DISTcost,1,LIM3DERROR);
								  DISTcost=max(TOL,abs(-log(max(TOL,DISTcost)))); 
			
								  if (!isinf(DISTcost) & !isnan(DISTcost)){
								      NOTERASED.push_back(cols);
								      if (!WRITE_ALL_MASTER)
								    	  SET.subP << "- " << DISTcost << " " << varname[nobj] << cols << " ";
								      SET.masterP << "- " << DISTcost << " " << varname[nobj] << cols << " ";
								  }
							
							}
						
							cols++;
						    }
					      }
				      }
				}
			    }
		    }
	      }
	  }
	  

	  Ncols.push_back(cols);
	  
	  
	  // TEMPORAL BETWEEN 3D POSSIBILITIES
	  for (int fr=fr_ini;fr<=fr_end;fr++){
	      for (int ncam=0;ncam<SET.nCam;ncam++){
		  for (int ncam2=ncam+1;ncam2<SET.nCam;ncam2++){
		      for (int p=0;p<SET.frames[fr].cam[ncam].cam2[ncam2].objects3d.size();p++){
			      for (int jump=1;jump<=1;jump++){
				      if ((fr+jump)<=fr_end){
					      for (int p2=0;p2<SET.frames[fr+jump].cam[ncam].cam2[ncam2].objects3d.size();p2++){
						      if (SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].errdist>-1 & SET.frames[fr+jump].cam[ncam].cam2[ncam2].objects3d[p2].errdist>-1){
							  dist=SET.Distance(SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p],SET.frames[fr+jump].cam[ncam].cam2[ncam2].objects3d[p2]);
							  timediff=SET.frames[fr+jump].cam[ncam].cam2[ncam2].objects3d[p2].timet-SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].timet;
							  DISTcost=1-SET.DistProbability(dist,timediff,SET.maxspeed3D);
							  
							  DISTcost=max(TOL,abs(-log(max(TOL,DISTcost))));
							  
							  if (!isinf(DISTcost) & !isnan(DISTcost)){
							      NOTERASED.push_back(cols);
							      if (!WRITE_ALL_MASTER)
							    	  SET.subP << "- " << DISTcost << " " << varname[nobj] << cols << " ";
							      SET.masterP << "- " << DISTcost << " " << varname[nobj] << cols << " ";
							     
							  }
										  
						      }
						      cols++;
					      }
				      }
			      }
		      }
		  }
	      }
	  } 
	
	  Ncols.push_back(cols);
	  
	  

	if (!WRITE_ALL_MASTER)
		SET.subP << endl;
    SET.masterP << endl;
    
    return Ncols;
}

// The flow coming out of an object and towards all the nodes in a camera have to be between 0 and 1

int CreateObject2DConstraints(CSet &SET,const int fr_ini, const int fr_end, const int nobj, int nConditions, int &nSlack, vector<int> &Ncols){
      
      int cols=0;
  
      //INPUTS
      for (int NCAM=0;NCAM<SET.nCam;NCAM++){
	  cols=0;
	  if (WRITE_ALL_MASTER)
		  SET.masterP << "INCon" << nConditions << ": ";
	  else
		  SET.subP << "INCon" << nConditions << ": " ;
	  nConditions++;
	  for (int fr=fr_ini;fr<=fr_end;fr++){  
	      for (int ncam=0;ncam<SET.nCam;ncam++){
		  for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		      if (ncam==NCAM){
		    	  if (WRITE_ALL_MASTER)
		    		  SET.masterP << "+ " << varname[nobj] << cols << " ";
		    	  else
		    		  SET.subP << "+ " << varname[nobj] << cols << " ";
		      }
		      cols++;
		  }
	      }
	  }
	  if (WRITE_ALL_MASTER)
		  SET.masterP << "<= 1" << endl;
	  else
		  SET.subP << "<= 1" << endl;
      }
     
      
      // OUTPUTS 
      for (int NCAM=0;NCAM<SET.nCam;NCAM++){
	  cols=Ncols[1]/2;
	  if (WRITE_ALL_MASTER)
		  SET.masterP << "OUTCon" << nConditions << ": " ;
	  else
		  SET.subP << "OUTCon" << nConditions << ": " ;
	  nConditions++;
	  for (int fr=fr_ini;fr<=fr_end;fr++){  
	      for (int ncam=0;ncam<SET.nCam;ncam++){
		  for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){
		      if (ncam==NCAM){
		    	  if (WRITE_ALL_MASTER)
		    		  SET.masterP << "+ " << varname[nobj] << cols << " ";
		    	  else
		    		  SET.subP << "+ " << varname[nobj] << cols << " ";
		      }
		      cols++;
		  }
	      }
	  }
	  if (WRITE_ALL_MASTER)
		  SET.masterP << "<= 1" << endl;
	  else
		  SET.subP << "<= 1" << endl;
      }
     
     
      
      return nConditions;
    
}

// The edges from object to 3D nodes must be activated if the two 2D nodes that create that 3D node have flow 1  0<=f1+f2-2f<=1; f=f1*f2

int Create2D3DConstraints( CSet &SET,  const int fr_ini, const int fr_end, const int nobj, const vector<int> Ncols, int nConditions, int &nSlack){
  
    // [0] object to 2d, [1] static 2d, [2] temporal 2d, [3] object to 3d, [4] 3d distances, [5] temporal 3D, [6] 2nd static for 3D
    int cols=Ncols[3],colsstatic=Ncols[1],colsstatic2=Ncols[1],inicols2=-1;
    
    // OBJECTS TO 3D POSSIBILITIES 
    for (int fr=fr_ini;fr<=fr_end;fr++){
	  colsstatic2+=SET.frames[fr].cam[0].objects2d.size();
	  inicols2=colsstatic2;		  
	  for (int ncam=0;ncam<SET.nCam;ncam++){	
		  for (int ncam2=ncam+1;ncam2<SET.nCam;ncam2++){
			for (int p=0;p<SET.frames[fr].cam[ncam].cam2[ncam2].objects3d.size();p++){
			    if (FindErased(cols,NOTERASED)){
			    	if (WRITE_ALL_MASTER){
			    		  SET.masterP << "ObjtoThreeDCon" << nConditions << ": " ;
						  nConditions++;
						  SET.masterP << " - " <<  varname[nobj] << colsstatic+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p ;
						  SET.masterP << " + " << varname[nobj] << cols;
						  SET.masterP << " <= 0" << endl;

						  SET.masterP << "ObjtoThreeDCon" << nConditions << ": " ;
						  nConditions++;
						  SET.masterP << " - " <<  varname[nobj] << colsstatic2+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p2;
						  SET.masterP << " + " << varname[nobj] << cols;
						  SET.masterP << " <= 0" << endl;

						  SET.masterP << "ObjtoThreeDCon" << nConditions << ": " ;
						  nConditions++;
						  SET.masterP <<  " - " << varname[nobj] << cols;
						  SET.masterP <<  " + " << varname[nobj] << colsstatic+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p  ;
						  SET.masterP << " + " <<  varname[nobj] << colsstatic2+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p2 ;
						  SET.masterP << " <= 1" << endl;
			    	}else{
						  SET.subP << "ObjtoThreeDCon" << nConditions << ": " ;
						  nConditions++;
						  SET.subP << " - " <<  varname[nobj] << colsstatic+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p ;
						  SET.subP << " + " << varname[nobj] << cols;
						  SET.subP << " <= 0" << endl;

						  SET.subP << "ObjtoThreeDCon" << nConditions << ": " ;
						  nConditions++;
						  SET.subP << " - " <<  varname[nobj] << colsstatic2+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p2;
						  SET.subP << " + " << varname[nobj] << cols;
						  SET.subP << " <= 0" << endl;

						  SET.subP << "ObjtoThreeDCon" << nConditions << ": " ;
						  nConditions++;
						  SET.subP <<  " - " << varname[nobj] << cols;
						  SET.subP <<  " + " << varname[nobj] << colsstatic+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p  ;
						  SET.subP << " + " <<  varname[nobj] << colsstatic2+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p2 ;
						  SET.subP << " <= 1" << endl;
			    	}
				
			    }else{
			    	if (WRITE_ALL_MASTER){
			    	  SET.masterP << "ObjtoThreeDCon" << nConditions << ": " ;
					  nConditions++;
					  SET.masterP <<  " + " << varname[nobj] << colsstatic+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p  ;
					  SET.masterP << " + " <<  varname[nobj] << colsstatic2+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p2 ;
					  SET.masterP << " <= 1" << endl;
			    	}else{
					  SET.subP << "ObjtoThreeDCon" << nConditions << ": " ;
					  nConditions++;
					  SET.subP <<  " + " << varname[nobj] << colsstatic+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p  ;
					  SET.subP << " + " <<  varname[nobj] << colsstatic2+SET.frames[fr].cam[ncam].cam2[ncam2].objects3d[p].p2 ;
					  SET.subP << " <= 1" << endl;
			    	}
			    }
			    
			    cols++;
			}
			colsstatic2+=SET.frames[fr].cam[ncam2].objects2d.size();
		  }
		  if (ncam+1<SET.nCam){
		    inicols2+=SET.frames[fr].cam[ncam+1].objects2d.size();
		  }
		  colsstatic2=inicols2;
		  
		  colsstatic+=SET.frames[fr].cam[ncam].objects2d.size();
	  }
    }
    return nConditions;
  
}


// The edges between 3D nodes must be activated if the two nodes have flow 1  0<=f1+f2-2f<=1; f=f1*f2

int Create3D3DConstraints( CSet &SET, const int fr_ini, const int fr_end, const int nobj, const vector<int> Ncols, int nConditions, int &nSlack){
  
    // [0] object to 2d, [1] static 2d, [2] temporal 2d, [3] object to 3d, [4] 3d distances, [5] temporal 3D, [6] 2nd static for 3D
    int cols=Ncols[4],colsobj=Ncols[3],colsobj2=Ncols[3],inicols2=-1;
    
    for (int fr=fr_ini;fr<=fr_end;fr++){
	  for (int ncam=0;ncam<SET.nCam;ncam++){
		inicols2=colsobj;
		for (int ncam2=ncam+1;ncam2<SET.nCam;ncam2++){
			for (int p=0;p<SET.frames[fr].cam[ncam].cam2[ncam2].objects3d.size();p++){
			      colsobj2=inicols2;
			      for (int ncam3=ncam;ncam3<SET.nCam;ncam3++){
				    for (int ncam4=ncam3+1;ncam4<SET.nCam;ncam4++){
					    for (int p2=0;p2<SET.frames[fr].cam[ncam3].cam2[ncam4].objects3d.size();p2++){
						  if (ncam3>ncam || ncam4>ncam2){
							if (FindErased(cols,NOTERASED) & FindErased(colsobj,NOTERASED) & FindErased(colsobj2,NOTERASED)){
									if (WRITE_ALL_MASTER){
									  SET.masterP << "ThreeDdistCon" << nConditions << ": " ;
									  nConditions++;
									  SET.masterP << " - " << varname[nobj] << colsobj ;
									  SET.masterP << " + " <<  varname[nobj] << cols;
									  SET.masterP << " <= 0" << endl;

									  SET.masterP << "ThreeDdistCon" << nConditions << ": " ;
									  nConditions++;
									  SET.masterP <<  " - " << varname[nobj] << colsobj2 ;
									  SET.masterP << " + " <<  varname[nobj] << cols;
									  SET.masterP << " <= 0" << endl;

									  SET.masterP << "ThreeDdistCon" << nConditions << ": " ;
									  nConditions++;
									  SET.masterP << " - " <<  varname[nobj] << cols  ;
									  SET.masterP << " + " <<  varname[nobj] << colsobj ;
									  SET.masterP << " + " <<  varname[nobj] << colsobj2;
									  SET.masterP << " <= 1" << endl;
									}else{
									  SET.subP << "ThreeDdistCon" << nConditions << ": " ;
									  nConditions++;
									  SET.subP << " - " << varname[nobj] << colsobj ;
									  SET.subP << " + " <<  varname[nobj] << cols;
									  SET.subP << " <= 0" << endl;

									  SET.subP << "ThreeDdistCon" << nConditions << ": " ;
									  nConditions++;
									  SET.subP <<  " - " << varname[nobj] << colsobj2 ;
									  SET.subP << " + " <<  varname[nobj] << cols;
									  SET.subP << " <= 0" << endl;

									  SET.subP << "ThreeDdistCon" << nConditions << ": " ;
									  nConditions++;
									  SET.subP << " - " <<  varname[nobj] << cols  ;
									  SET.subP << " + " <<  varname[nobj] << colsobj ;
									  SET.subP << " + " <<  varname[nobj] << colsobj2;
									  SET.subP << " <= 1" << endl;
									}
							   
							}else if (FindErased(colsobj,NOTERASED) & FindErased(colsobj2,NOTERASED)){
								if (WRITE_ALL_MASTER){
								  SET.masterP << "ThreeDdistCon" << nConditions << ": " ;
								  nConditions++;
								  SET.masterP << " + " <<  varname[nobj] << colsobj ;
								  SET.masterP << " + " <<  varname[nobj] << colsobj2;
								  SET.masterP << " <= 1" << endl;
								}else{
							      SET.subP << "ThreeDdistCon" << nConditions << ": " ;
							      nConditions++;
							      SET.subP << " + " <<  varname[nobj] << colsobj ;
							      SET.subP << " + " <<  varname[nobj] << colsobj2;
							      SET.subP << " <= 1" << endl;
								}
							}
							cols++;
						  }
						  
						  colsobj2++;
					    }
				    }
			      }
			      
			      colsobj++;
			}
		}
	  }
      }
      return nConditions;
}


int CreateTemporal3DConstraints(CSet &SET, const int fr_ini, const int fr_end, const int nobj, const vector<int> Ncols, int nConditions){
  
    // [0] object to 2d, [1] static 2d, [2] temporal 2d, [3] object to 3d, [4] 3d distances, [5] temporal 3D, [6] 2nd static for 3D
    int temp3Dcols=Ncols[5],colsobj=Ncols[3],colsobj2=Ncols[3],inicols2=-1;
    
    for (int FR=fr_ini;FR<=fr_end;FR++){
	  inicols2=colsobj;
	  for (int NCAM=0;NCAM<SET.nCam;NCAM++){
		for (int NCAM2=NCAM+1;NCAM2<SET.nCam;NCAM2++){
			for (int P=0;P<SET.frames[FR].cam[NCAM].cam2[NCAM2].objects3d.size();P++){
			       colsobj2=inicols2;
			       for (int fr=FR;(fr<=FR+1 & fr<=fr_end);fr++){
					for (int ncamd=0;ncamd<SET.nCam;ncamd++){
					    for (int ncam2d=ncamd+1;ncam2d<SET.nCam;ncam2d++){
						for (int p2=0;p2<SET.frames[fr].cam[ncamd].cam2[ncam2d].objects3d.size();p2++){       
						      if (ncamd==NCAM & ncam2d==NCAM2 & fr>FR){
							  if (FindErased(temp3Dcols,NOTERASED) && FindErased(colsobj,NOTERASED) & FindErased(colsobj2,NOTERASED) ){
								  if (WRITE_ALL_MASTER){
									SET.masterP << "TEMP3D" << nConditions << ": " ;
									nConditions++;
									SET.masterP << " - " << varname[nobj] << colsobj ;
									SET.masterP << " + " <<  varname[nobj] << temp3Dcols;
									SET.masterP << " <= 0" << endl;

									SET.masterP << "TEMP3D" << nConditions << ": " ;
									nConditions++;
									SET.masterP <<  " - " << varname[nobj] << colsobj2 ;
									SET.masterP << " + " <<  varname[nobj] << temp3Dcols;
									SET.masterP << " <= 0" << endl;

									SET.masterP << "TEMP3D" << nConditions << ": " ;
									nConditions++;
									SET.masterP << " - " <<  varname[nobj] << temp3Dcols  ;
									SET.masterP << " + " <<  varname[nobj] << colsobj ;
									SET.masterP << " + " <<  varname[nobj] << colsobj2;
									SET.masterP << " <= 1" << endl;
								  }else{
									SET.subP << "TEMP3D" << nConditions << ": " ;
									nConditions++;
									SET.subP << " - " << varname[nobj] << colsobj ;
									SET.subP << " + " <<  varname[nobj] << temp3Dcols;
									SET.subP << " <= 0" << endl;

									SET.subP << "TEMP3D" << nConditions << ": " ;
									nConditions++;
									SET.subP <<  " - " << varname[nobj] << colsobj2 ;
									SET.subP << " + " <<  varname[nobj] << temp3Dcols;
									SET.subP << " <= 0" << endl;

									SET.subP << "TEMP3D" << nConditions << ": " ;
									nConditions++;
									SET.subP << " - " <<  varname[nobj] << temp3Dcols  ;
									SET.subP << " + " <<  varname[nobj] << colsobj ;
									SET.subP << " + " <<  varname[nobj] << colsobj2;
									SET.subP << " <= 1" << endl;
								  }
								
								
							   }else if (FindErased(colsobj,NOTERASED) & FindErased(colsobj2,NOTERASED)){
								   if (WRITE_ALL_MASTER){
									    SET.masterP << "TEMP3D" << nConditions << ": " ;
										nConditions++;
										SET.masterP << " + " <<  varname[nobj] << colsobj ;
										SET.masterP << " + " <<  varname[nobj] << colsobj2;
										SET.masterP << " <= 1" << endl;
								   }else{
										SET.subP << "TEMP3D" << nConditions << ": " ;
										nConditions++;
										SET.subP << " + " <<  varname[nobj] << colsobj ;
										SET.subP << " + " <<  varname[nobj] << colsobj2;
										SET.subP << " <= 1" << endl;
								   }
							   }
							  temp3Dcols++;
						      }
						      colsobj2++;
						}
					    }
					}					
				}
				colsobj++;
			}
		}
	  }
      }
      return nConditions;
  
}


// The flow coming in a node  + S = static;
// flow coming out + T = static


int Create2DNodeConstraints( CSet &SET, const int fr_ini, const int fr_end, const int nobj, const vector<int> Ncols, int nConditions){
  
	// [0] object to 2d, [1] static 2d, [2] temporal 2d, [3] object to 3d, [4] 3d distances, [5] temporal 3D, [6] 2nd static for 3D
	int staticcols=Ncols[1],incols=0,outcols=Ncols[1]/2,tempcols=Ncols[2];
	
	
	// IN FLOW + S = STATIC
	for (int FR=fr_ini;FR<=fr_end;FR++){
		for (int NCAM=0;NCAM<SET.nCam;NCAM++){
		      for (int P=0;P<SET.frames[FR].cam[NCAM].objects2d.size();P++){ 
		    	  if (WRITE_ALL_MASTER)
		    		  SET.masterP << "INplusSminusST" << nConditions << ": " ;
		    	  else
		    		  SET.subP << "INplusSminusST" << nConditions << ": " ;
			      nConditions++;
			      tempcols=Ncols[2];
			      for (int fr=fr_ini;fr<=fr_end;fr++){
				      for (int ncam=0;ncam<SET.nCam;ncam++){
					    for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){ 
						    for (int jump=1;jump<=SET.RecoverFrames;jump++){
							    if ((fr+jump)<=fr_end){
								    for (int p2=0;p2<SET.frames[fr+jump].cam[ncam].objects2d.size();p2++){
									    if (ncam==NCAM & (fr+jump)==FR & p2==P & FindErased(tempcols,NOTERASED)){
									    	if (WRITE_ALL_MASTER)
									    		SET.masterP << "+ " <<  varname[nobj] << tempcols<< " " ;
									    	else
									    		SET.subP << "+ " <<  varname[nobj] << tempcols<< " " ;
									    }
									    tempcols++;
								    }
							    }
						    }
					    }
				      }
			      }
			      if (WRITE_ALL_MASTER){
					  SET.masterP << "- " <<  varname[nobj] << staticcols << " ";
					  SET.masterP << "+ " <<  varname[nobj] << incols << " ";
					  SET.masterP << "= 0" << endl;
			      }else{
					  SET.subP << "- " <<  varname[nobj] << staticcols << " ";
					  SET.subP << "+ " <<  varname[nobj] << incols << " ";
					  SET.subP << "= 0" << endl;
			      }
			      staticcols++;
			      incols++;
		      }
		}
	}
	
	
	// OUT FLOW + T = STATIC

	staticcols=Ncols[1];tempcols=Ncols[2];
	for (int fr=fr_ini;fr<=fr_end;fr++){
		for (int ncam=0;ncam<SET.nCam;ncam++){
		      for (int p=0;p<SET.frames[fr].cam[ncam].objects2d.size();p++){ 
		    	  if (WRITE_ALL_MASTER)
		    		  SET.masterP << "OUTplusTminusST" << nConditions << ":" ;
		    	  else
		    		  SET.subP << "OUTplusTminusST" << nConditions << ":" ;
			      nConditions++;
			      for (int jump=1;jump<=SET.RecoverFrames;jump++){
				      if ((fr+jump)<=fr_end){
					      for (int p2=0;p2<SET.frames[fr+jump].cam[ncam].objects2d.size();p2++){
						      if (FindErased(tempcols,NOTERASED)){
						    	  if (WRITE_ALL_MASTER)
						    		  SET.masterP << " + " <<  varname[nobj] << tempcols  ;
						    	  else
						    		  SET.subP << " + " <<  varname[nobj] << tempcols  ;
						      }
						      tempcols++;
					      }
				      }
			      }
			      if (WRITE_ALL_MASTER){
			    	  SET.masterP << " - " <<  varname[nobj] << staticcols;
					  SET.masterP << " + " <<  varname[nobj] << outcols;
					  SET.masterP << " = 0" << endl;
			      }else{
					  SET.subP << " - " <<  varname[nobj] << staticcols;
					  SET.subP << " + " <<  varname[nobj] << outcols;
					  SET.subP << " = 0" << endl;
			      }
			      staticcols++;
			      outcols++;
		      }
		}
	}
	
	
	return nConditions;
	
	
}


void CreateSubproblemBounds(CSet &SET, const int fr_ini, const int fr_end, const int nobj, const vector<int> Ncols, const vector<int> nSlack){
  
	// [0] object to 2d, [1] static 2d, [2] temporal 2d, [3] object to 3d, [4] 3d distances, [5] temporal 3D, [6] 2nd static for 3D
	int cols=Ncols[0];


	if (WRITE_ALL_MASTER){
	  
	      for (cols=Ncols[0];cols<Ncols[2];cols++){
		      SET.masterP << "0 <= " <<  varname[nobj] << cols << " <= 1 " << endl;
	      }
	      
	      for (cols=Ncols[2];cols<Ncols[3];cols++){
			  if (FindErased(cols,NOTERASED)){
				  SET.masterP << "0 <= " <<  varname[nobj] << cols << " <= 1 " << endl;
			  }
	      }
	      

	  
	      for (cols=Ncols[3];cols<Ncols[6];cols++){
			  if (FindErased(cols,NOTERASED)){
				  SET.masterP << "0 <= " <<  varname[nobj] << cols << " <= 1 " << endl;
			  }
	      }
	}else{
		  for (cols=Ncols[0];cols<Ncols[2];cols++){
			  SET.subP << "0 <= " <<  varname[nobj] << cols << " <= 1 " << endl;
		  }

		  for (cols=Ncols[2];cols<Ncols[3];cols++){
			  if (FindErased(cols,NOTERASED)){
				  SET.subP << "0 <= " <<  varname[nobj] << cols << " <= 1 " << endl;
			  }
		  }


		  for (cols=Ncols[3];cols<Ncols[6];cols++){
			  if (FindErased(cols,NOTERASED)){
				  SET.subP << "0 <= " <<  varname[nobj] << cols << " <= 1 " << endl;
			  }
		  }

	}
	    
		
	
}

// Add 3D articulated distances, d-D where D is the articulated distance we know

int CreateMasterObjectiveFunction(CSet &SET,const int fr_ini, const int fr_end){
  
}


// 3D articulated distances (d-D) are activated when appropiate 0<=f1+f2-2f<=1; f=f1*f2
// All the statics summed have to be 1 for each detection
// All the other flows have to be between zero and 1

int CreateMasterConstraints(CSet &SET, const int fr_ini, const int fr_end, const vector<int> Ncols, int nConditions, int &masterSlack, const int gg){
  
	// DO NOT PUT ANY CONSTRAINT TO ZERO BECAUSE THEN WRITING TO INTEGERIZED_ZEROS IS INCORRECT
	// [0] object to 2d, [1] static 2d, [2] temporal 2d, [3] object to 3d, [4] 3d distances, [5] temporal 3D, [6] 2nd static for 3D
	
	for (int cols=Ncols[0];cols<Ncols[2];cols++){
		SET.masterP << "MasterConstr" << nConditions << ": ";
		nConditions++;
		for (int nobj=0;nobj<SET.nObj;nobj++){
		      if (nobj>0){
			  SET.masterP << " + ";
		      }
		      SET.masterP << varname[nobj] << cols; 
		}
		SET.masterP << " <= 1" << endl; 
	}
	
	
	
	
	for (int cols=Ncols[2];cols<Ncols[Ncols.size()-1];cols++){
	    if (FindErased(cols,NOTERASED)){
		SET.masterP << "MasterConstr" << nConditions << ": ";
		nConditions++;
		for (int nobj=0;nobj<SET.nObj;nobj++){
		      if (nobj>0){
			  SET.masterP << " + ";
		      }
		      SET.masterP << varname[nobj] << cols; 
		}
		SET.masterP << " <= 1" << endl; 
	    }
	}
	

	return nConditions;
  
}



// Bounds for master flows

int CreateMasterBounds(CSet &SET, const int fr_ini, const int fr_end, const vector<int> Ncols, const int masterSlack){
  
	
	for (int ns=0;ns<masterSlack;ns++){
	      SET.masterP << "0 <= Mslack" <<  ns << " <= 1 " << endl;
	}
	    
	   
}



vector<int> CreateDWproblem(CSet &SET, const int fr_ini, const int fr_end, const double tdiff, const int iternum){


	double THspeed=SET.maxspeed;	
	int nConditions=0,masterSlack=0,numsubP=0;
	vector<int> nSlack;
	vector<int>Ncols; // [0] object to 2d, [1] static 2d, [2] temporal 2d, [3] object to 3d, [4] 3d distances, [5] temporal 3D, [6] 2nd static for 3D
	strcpy(SET.ofilename,SET.MAIN_DIR);
	strcat(SET.ofilename,"master.cplex");
	SET.masterP.open(SET.ofilename);
	SET.masterP << "Minimize" << endl;
	SET.masterP << "objective: " ;
	    
	/***************** CREATE GUIDE FILE *********************/
	strcpy(SET.ofilename,SET.MAIN_DIR);
	strcat(SET.ofilename,"guide_file");
	SET.guidefile.open(SET.ofilename);
	SET.guidefile << SET.nObj << endl;
	for (int nobj=0;nobj<SET.nObj;nobj++){  
	    SET.guidefile << "subP_" << nobj << ".cplex" << endl;
	}
	SET.guidefile << "master.cplex" << endl << "master.cplex" << endl << "0.0" << endl;
	SET.guidefile.close();
	/*********************************************************/
	
	
	if (iternum==0){
		Create3DPossibilitiesMultiPeople(SET,fr_ini,fr_end);
	}

	for (int nobj=0;nobj<SET.nObj;nobj++){
	    
	    Ncols.clear();
	    NOTERASED.clear();
	   
		
	    char StringObj[256];
	    sprintf(StringObj,"%d",numsubP);
	    strcpy(SET.ofilename,SET.MAIN_DIR);
	    strcat(SET.ofilename,"subP_");
	    strcat(SET.ofilename,StringObj);
	    numsubP++;
	    strcat(SET.ofilename,".cplex");
	    
	    SET.subP.open(SET.ofilename);
	    
	    SET.subP << "Minimize" << endl;
	    SET.subP << "objective: " << endl;
	    
	    Ncols=CreateObjectiveFunction(SET, fr_ini,fr_end,nobj, Ncols);
	    SET.subP.close();
	    
	    
	}
	 
	SET.masterP << endl << "Subject To " << endl;
	numsubP=0;
	

	for (int nobj=0;nobj<SET.nObj;nobj++){
	    
	  
		  char StringObj[256];
		  sprintf(StringObj,"%d",numsubP);
		  strcpy(SET.ofilename,SET.MAIN_DIR);
		  strcat(SET.ofilename,"subP_");
		  strcat(SET.ofilename,StringObj);
		  numsubP++;
		  strcat(SET.ofilename,".cplex");
		  
		  SET.subP.open(SET.ofilename,ios_base::app);
		  
		  SET.subP << endl << "Subject To " << endl;
	      
	
		  nConditions=CreateObject2DConstraints( SET, fr_ini,fr_end,nobj,nConditions,nSlack[nobj],Ncols);
		  nConditions=Create2DNodeConstraints( SET,fr_ini, fr_end,nobj, Ncols,  nConditions);
    
		  nConditions=Create2D3DConstraints( SET, fr_ini,fr_end,nobj,Ncols,nConditions,nSlack[nobj]);
		  nConditions=Create3D3DConstraints( SET, fr_ini,fr_end,nobj,Ncols,nConditions,nSlack[nobj]);
		  nConditions=CreateTemporal3DConstraints(SET, fr_ini,fr_end,nobj,Ncols,nConditions);
	

		  SET.subP.close();
	    
	      
	    
	}

	numsubP=0;
	
	for (int nobj=0;nobj<SET.nObj;nobj++){

	     
		char StringObj[256];
		sprintf(StringObj,"%d",numsubP);
		strcpy(SET.ofilename,SET.MAIN_DIR);
		strcat(SET.ofilename,"subP_");
		strcat(SET.ofilename,StringObj);
		strcat(SET.ofilename,".cplex");
		numsubP++;

		
		SET.subP.open(SET.ofilename,ios_base::app);
		
		SET.subP << endl << "bounds " << endl;
		CreateSubproblemBounds( SET, fr_ini,fr_end,nobj,Ncols,nSlack);
		SET.subP << "end" << endl;  
		SET.subP.close();
	      

	}
	
	nConditions=CreateMasterConstraints(SET,fr_ini,fr_end,Ncols,nConditions,masterSlack,iternum);
	
	  	
	
	SET.masterP << endl << "bounds " << endl;
	SET.masterP <<  " 0 <= DUMMY <= 1" << endl;
	
	SET.masterP << endl << "end" << endl; 
	SET.masterP.close();

	NOTERASED.clear();

	return Ncols;
}
