#include <iostream>
#include <vector>
#include <limits>

#include "Set.h"



#ifndef MAX_COLORS
#define MAX_COLORS 10000000000
#endif

#define _USE_MATH_DEFINES



using namespace std;


CSet::CSet(){
}

CSet::CSet(int _nCam){
  nCam=_nCam;
 }


CSet::~CSet(){
}

void CSet::eraseSet(){
	vector<CFrame>().swap(frames);	
}





void CSet::showDoubleMatrix( int size1, int size2, double *C){

	for(int i =0; i< size1; i++){
		for(int j =0; j< size2; j++){
			cout<<" "<<C[i*size2+j] <<" ";
		}
		cout<<endl;
	}
	cout<<endl;
	
}

void CSet::showIntMatrix(int size1, int size2, int *C){

	for(int i =0; i< size1; i++){
		for(int j =0; j< size2; j++){
			cout<<" "<<C[i*size2+j] <<" ";
		}
		cout<<endl;
	}
	cout<<endl;
}

void CSet::Reconstruct3Dpositions(){
  
  // TO BE CONSTRUCTED!!!
  for (int fr=0;fr<frames.size();fr++){
      for (int ncam=0;ncam<frames[fr].cam.size();ncam++){
	  for (int p=0;p<frames[fr].cam[ncam].objects3d.size();p++){
	      frames[fr].cam[ncam].objects3d[p].x=-1;
	      frames[fr].cam[ncam].objects3d[p].y=-1;
	      frames[fr].cam[ncam].objects3d[p].z=-1;
	  }
      }
  }
  vector<int>xval,yval,zval;
  for (int fr=0;fr<frames.size();fr++){
      for (int ncam=0;ncam<frames[fr].cam.size();ncam++){
	  for (int p=0;p<frames[fr].cam[ncam].objects2d.size();p++){
	      xval.clear();yval.clear();zval.clear();
	      int ID=frames[fr].cam[ncam].objects2d[p].autoclass;
	      for (int ncam2=0;ncam2<frames[fr].cam.size();ncam2++){
		  for (int p2=0;p2<frames[fr].cam[ncam].objects2d.size();p2++){
		      if (ID==frames[fr].cam[ncam2].objects2d[p2].autoclass){
			  for (int p3=0;p3<frames[fr].cam[ncam].cam2[ncam2].objects3d.size();p3++){
			      if (frames[fr].cam[ncam].cam2[ncam2].objects3d[p3].p==p && frames[fr].cam[ncam].cam2[ncam2].objects3d[p3].p2==p2){
				  xval.push_back(frames[fr].cam[ncam].cam2[ncam2].objects3d[p3].x);
				  yval.push_back(frames[fr].cam[ncam].cam2[ncam2].objects3d[p3].y);
				  zval.push_back(frames[fr].cam[ncam].cam2[ncam2].objects3d[p3].z);
			      }
			  }
		      }
		  }
	      }
	      for (int val=0;val<xval.size();val++){
		  frames[fr].cam[ncam].objects3d[p].x=xval[val]/xval.size();
		  frames[fr].cam[ncam].objects3d[p].y=yval[val]/xval.size();
		  frames[fr].cam[ncam].objects3d[p].z=zval[val]/xval.size();
	      }
	  }
      }
  }
  
  

}

double CSet::LineDistance(CData &p0,CData &p02,CData &pc){
  

   CData p1,p2,p3,p4,p13,p43,p21,pa,pb;
   double d1343,d4321,d1321,d4343,d2121;
   double numer,denom;
   double mua,mub;

   p1.x=p0.x;p1.y=p0.y;p1.z=p0.z;
   p2.x=p0.x2;p2.y=p0.y2;p2.z=p0.z2;
   p3.x=p02.x;p3.y=p02.y;p3.z=p02.z;
   p4.x=p02.x2;p4.y=p02.y2;p4.z=p02.z2;
   
   p13.x = p1.x - p3.x;
   p13.y = p1.y - p3.y;
   p13.z = p1.z - p3.z;
   p43.x = p4.x - p3.x;
   p43.y = p4.y - p3.y;
   p43.z = p4.z - p3.z;
   if (abs(p43.x) < EPS && abs(p43.y) < EPS && abs(p43.z) < EPS)
      return(false);
   p21.x = p2.x - p1.x;
   p21.y = p2.y - p1.y;
   p21.z = p2.z - p1.z;
   if (abs(p21.x) < EPS && abs(p21.y) < EPS && abs(p21.z) < EPS)
      return(false);

   d1343 = p13.x * p43.x + p13.y * p43.y + p13.z * p43.z;
   d4321 = p43.x * p21.x + p43.y * p21.y + p43.z * p21.z;
   d1321 = p13.x * p21.x + p13.y * p21.y + p13.z * p21.z;
   d4343 = p43.x * p43.x + p43.y * p43.y + p43.z * p43.z;
   d2121 = p21.x * p21.x + p21.y * p21.y + p21.z * p21.z;

   denom = d2121 * d4343 - d4321 * d4321;
   if (abs(denom) < EPS)
      return(false);
   numer = d1343 * d4321 - d1321 * d4343;

   mua = numer / denom;
   mub = (d1343 + d4321 * (mua)) / d4343;

   pa.x = p1.x + mua * p21.x;
   pa.y = p1.y + mua * p21.y;
   pa.z = p1.z + mua * p21.z;
   pb.x = p3.x + mub * p43.x;
   pb.y = p3.y + mub * p43.y;
   pb.z = p3.z + mub * p43.z;
   
   pc.x=0.5*(pa.x+pb.x);
   pc.y=0.5*(pa.y+pb.y);
   pc.z=0.5*(pa.z+pb.z);

   return(Distance(pa,pb));
}


double CSet::Distance(CData &p0,CData &p1){

	return sqrt((p0.x-p1.x) * (p0.x-p1.x)+
			(p0.y-p1.y) * (p0.y-p1.y) +(p0.z-p1.z) * (p0.z-p1.z));
}

double CSet::DistancePix(CData &p0,CData &p1){

	return sqrt((p0.x-p1.x) * (p0.x-p1.x)+
			(p0.y-p1.y) * (p0.y-p1.y));
}


double CSet::SpeedNorm(CData &p0,CData &p1){

	double norm0=sqrt(p0.vx*p0.vx + p0.vy*p0.vy);
	double norm1=sqrt(p1.vx*p1.vx + p1.vy*p1.vy);
	
	return abs(norm0-norm1);
	
}

double CSet::SpeedOri(CData &p0,CData &p1){

	double norm0=sqrt(p0.vx*p0.vx + p0.vy*p0.vy);
	double norm1=sqrt(p1.vx*p1.vx + p1.vy*p1.vy);
	
	if (norm0==0 || norm1==0){
	      return 0;
	}else{
	      return acos(p0.vx/norm0*p1.vx/norm1+p0.vy/norm0*p1.vy/norm1);
	}

}


double CSet::Acceleration(CData &p0,CData &p1, const double tdiff){

	return sqrt(((p1.vx-p0.vx)/tdiff)*((p1.vx-p0.vx)/tdiff)+((p1.vy-p0.vy)/tdiff)*((p1.vy-p0.vy)/tdiff));

}




void CSet::clearIDs(){
	
      for (int fr=0;fr<frames.size();fr++){
	    for (int ncam=0;ncam<nCam;ncam++){
		  for (int p=0;p<frames[fr].cam[ncam].objects2d.size();p++){
			frames[fr].cam[ncam].objects2d[p].oldclass=frames[fr].cam[ncam].objects2d[p].autoclass;
			frames[fr].cam[ncam].objects2d[p].autoclass=-1;
		  }
	    }
      }
}


void CSet::clearSpeeds(){
	
      for (int fr=0;fr<frames.size();fr++){
	  for (int ncam=0;ncam<nCam;ncam++){
		for (int p=0;p<frames[fr].cam[ncam].objects2d.size();p++){
		      frames[fr].cam[ncam].objects2d[p].vx=-1;
		      frames[fr].cam[ncam].objects2d[p].vy=-1;
		      frames[fr].cam[ncam].objects2d[p].vz=-1;   
		}
	  }
      }
  
}


void CSet::ComputeSpeeds(){
      
      for (int ncam=0;ncam<nCam;ncam++){
	      double speed[2];
	      double tdiff=0.0;
	      for (int fr=1;fr<frames.size();fr++){
		    for (int p=0;p<frames[fr].cam[ncam].objects2d.size();p++){
			  for (int p2=0;p2<frames[fr-1].cam[ncam].objects2d.size();p2++){
				if (frames[fr].cam[ncam].objects2d[p].autoclass>=0 && frames[fr].cam[ncam].objects2d[p].autoclass==frames[fr-1].cam[ncam].objects2d[p2].autoclass){
				      tdiff=frames[fr].cam[ncam].objects2d[p].timet-frames[fr-1].cam[ncam].objects2d[p2].timet;
				      speed[0]=(frames[fr].cam[ncam].objects2d[p].x-frames[fr-1].cam[ncam].objects2d[p2].x)/tdiff;
				      speed[1]=(frames[fr].cam[ncam].objects2d[p].y-frames[fr-1].cam[ncam].objects2d[p2].y)/tdiff;
				      frames[fr].cam[ncam].objects2d[p].vx=speed[0];
				      frames[fr].cam[ncam].objects2d[p].vy=speed[1];
				      frames[fr].cam[ncam].objects2d[p].vz=0;
				}
			  }	    
		    }
	      }
	      
	      // Copy speeds of frame 1 to frame 0
	      for (int fr=0;fr<(frames.size()-1);fr++){
		    for (int p=0;p<frames[fr].cam[ncam].objects2d.size();p++){
			  if (frames[fr].cam[ncam].objects2d[p].vx==-1 && frames[fr].cam[ncam].objects2d[p].vy==-1 && frames[fr].cam[ncam].objects2d[p].vz==-1){
				bool found=false;
				int p2=0;
				while (!found && p2<frames[fr+1].cam[ncam].objects2d.size()){
				      if (frames[fr].cam[ncam].objects2d[p].autoclass>=0 && frames[fr+1].cam[ncam].objects2d[p2].autoclass==frames[fr].cam[ncam].objects2d[p].autoclass){
					    found=true;
					    frames[fr].cam[ncam].objects2d[p].vx=frames[fr+1].cam[ncam].objects2d[p2].vx;
					    frames[fr].cam[ncam].objects2d[p].vy=frames[fr+1].cam[ncam].objects2d[p2].vy;
					    frames[fr].cam[ncam].objects2d[p].vz=frames[fr+1].cam[ncam].objects2d[p2].vz;
				      }
				      p2++;
				}
			  }
		    }
	      }
      }

}


void CSet::Frame2Particles(){
  
    for (int ncam=0;ncam<nCam;ncam++){
	  ParticlesByNum.clear();
	  ComputeSpeeds();
	  CFrame emptyframe;
	  CCamera emptycamera;
	  ParticlesByNum.push_back(emptyframe);
	  for (int cc=0;cc<nCam;cc++){
		  ParticlesByNum[ParticlesByNum.size()-1].cam.push_back(emptycamera);
	  }
	
	  for (int fr=0;fr<frames.size();fr++){
	      for (int p=0;p<frames[fr].cam[ncam].objects2d.size();p++){
		  if (frames[fr].cam[ncam].objects2d[p].autoclass>=0){
			while(ParticlesByNum.size()<=frames[fr].cam[ncam].objects2d[p].autoclass){
			      ParticlesByNum.push_back(emptyframe);
			      for (int cc=0;cc<nCam;cc++){
				  ParticlesByNum[ParticlesByNum.size()-1].cam.push_back(emptycamera);
			      }
			}
			ParticlesByNum[frames[fr].cam[ncam].objects2d[p].autoclass].fn=1;
			ParticlesByNum[frames[fr].cam[ncam].objects2d[p].autoclass].cam[ncam].objects2d.push_back(frames[fr].cam[ncam].objects2d[p]);
      
		  }
	      }
	  }
    }
    
   
      
}


// Probability given the distance between objects

double CSet::DistProbability(double dist, const double timediff,const double THspeed){

	dist=dist/timediff;//*double(fr_diff);
	
	return (0.5*(1+erf(-(dist-THspeed/2)/(2*THspeed/8))));
	
}




// No change is zero
int CSet::CalculateChanges(){

    int changes=0;
    for (int ncam=0;ncam<nCam;ncam++){
	for (int fr=0;fr<frames.size();fr++){
	    for (int p=0;p<frames[fr].cam[ncam].objects2d.size();p++){
		if (frames[fr].cam[ncam].objects2d[p].autoclass!=frames[fr].cam[ncam].objects2d[p].oldclass){
		    return 1;
		}
	    }
	}
    }
    return 0;

}


int CSet::CountParticles(){

	int nump=0;
	for (int ncam=0;ncam<nCam;ncam++){
	      for (int fr=0;fr<frames.size();fr++){
		  nump=nump+frames[fr].cam[ncam].objects2d.size();
	      }
	}
	return nump;
	
}



void CSet::EraseInterpolated(){
    
    for (int fr=0;fr<frames.size();fr++){
	  for (int ncam=0;ncam<nCam;ncam++){
	    for (int p=frames[fr].cam[ncam].objects2d.size()-1;p>=0;p--){
		if (frames[fr].cam[ncam].objects2d[p].created){
		    frames[fr].cam[ncam].objects2d.erase(frames[fr].cam[ncam].objects2d.begin()+p);
		}
	    }
	  }
    }

}


void CSet::EraseUnmatched(){

    for (int fr=0;fr<frames.size();fr++){
	  for (int ncam=0;ncam<nCam;ncam++){
	      for (int p=frames[fr].cam[ncam].objects2d.size()-1;p>=0;p--){
		    if (frames[fr].cam[ncam].objects2d[p].autoclass==-1){
			  frames[fr].cam[ncam].objects2d.erase(frames[fr].cam[ncam].objects2d.begin()+p);
		    }
	      }
	}
    }

}

void CSet::EraseCreatedAndUnmatched(){

    for (int fr=0;fr<frames.size();fr++){
	  for (int ncam=0;ncam<nCam;ncam++){
	      for (int p=frames[fr].cam[ncam].objects2d.size()-1;p>=0;p--){
		    if (frames[fr].cam[ncam].objects2d[p].created && frames[fr].cam[ncam].objects2d[p].autoclass==-1){
			  frames[fr].cam[ncam].objects2d.erase(frames[fr].cam[ncam].objects2d.begin()+p);
		    }
	      }
	}
    }

}

void CSet::EraseTrajectories(){	//Erase trajectories with length < MINFRAMES 
	
    for (int ncam=0;ncam<nCam;ncam++){
	vector <int> ToErase;
	for (int p=0;p<ParticlesByNum.size();p++){
	      if (ParticlesByNum[p].cam[ncam].objects2d.size()>0 && ParticlesByNum[p].cam[ncam].objects2d.size()<MINFRAMES){
		  ToErase.push_back(ParticlesByNum[p].cam[ncam].objects2d[0].autoclass);
	      }
	}
	
	
	
	for (int fr=0;fr<frames.size();fr++){
	      for (int p=frames[fr].cam[ncam].objects2d.size()-1;p>=0;p--){
		    if (frames[fr].cam[ncam].objects2d[p].autoclass==-1){
			  frames[fr].cam[ncam].objects2d.erase(frames[fr].cam[ncam].objects2d.begin()+p);
		    }else{
			  int kk=0;
			  while (kk<ToErase.size()){
			      if (frames[fr].cam[ncam].objects2d[p].autoclass==ToErase[kk]){
				  frames[fr].cam[ncam].objects2d.erase(frames[fr].cam[ncam].objects2d.begin()+p);
				  kk=ToErase.size();
			      }
			      kk++;
			  }
		    }
	      }
	}
    }
	
	
}

void CSet::Erase3DPossibilities(const int startfr,const int endfr){
    
    for (int fr=startfr;fr<endfr;fr++){
	for (int ncam=0;ncam<nCam;ncam++){
	    frames[fr].cam[ncam].cam2.clear();
	}
    }
  
}


