#ifndef _PARTICLESSETS_
#define _PARTICLESSETS_


#include "Frame.h"

#include <time.h>
#include <iostream>
#include <cstdlib>
#include <cmath>
#include <sstream>
#include <stdio.h>
#include <stdlib.h>
#include <complex>
#include <string.h>
#include <ctype.h>
#include <fstream>
#include <ostream>
#include <iomanip>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/types.h>

#ifndef SAFETY_MARGIN
#define SAFETY_MARGIN 0
#endif

#ifndef C_VIRTUAL_VALUE
#define C_VIRTUAL_VALUE 100000.0
#endif

#define EPS numeric_limits<double>::epsilon()


#ifndef MINFRAMES
#define MINFRAMES 2	
#endif



const int c_strSize = 256;
using namespace std;


class CSet{

public:
	CSet();
	CSet(int _nCam);
	~CSet();


	void eraseSet();
	void showDoubleMatrix(int size1, int size2,double *C);
	void showIntMatrix(int size1, int size2, int *C);


	void addFrameInfo();


	//Functions to calculate the Cost Matrix
	double LineDistance(CData &p0,CData &p02,CData &pc);
	double Distance(CData &p0,CData &p1);
	double DistancePix(CData &p0,CData &p1);
	double distancePrediction(CFrame &begin, CFrame &end, const int pb, const int pe);
	double SpeedOri(CData &p0,CData &p1);
	double Acceleration(CData &p0,CData &p1, const double tdiff);
	double SpeedNorm(CData &p0,CData &p1);
	double distance2BB(CData &p1,CData &pclosest, const bool back);
	void addRandomNoise();
	void FindSpeed(); //for ParticlesByNum
	void Frame2Particles();
	void clearIDs();
	void clearSpeeds();
	void ComputeSpeeds(); //directly for frames
	void EraseInterpolated();
	void Erase3DPossibilities(const int startfr,const int endfr);
	void Reconstruct3Dpositions();
	
	double DistProbability(double dist, const double timediff,const double THspeed);
	int CalculateChanges();
	int CountParticles();
	
	void EraseTrajectories();
	void EraseUnmatched();
	void EraseCreatedAndUnmatched();
	
	vector<CFrame> frames;
	
	vector<CFrame> ParticlesByNum;
	
	char filename[256];
	char ofilename[256];
	char costfile[256];
	char *MAIN_DIR;
	char *FILE;
	char *DWSOLVER_DIR;
	ofstream costs;
	    
	ofstream subP;
	ofstream masterP;
	ofstream guidefile;
	
	int usedColors;
	
	double maxspeed;
	double maxspeed3D;
	int nCam;
	int nObj;
	int RecoverFrames;
	double base_jump;
	
};
#endif